//
//  Gob1MenuViewController.h
//  scummvm
//
//  Created by DotEmu on 17/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "loadViewController.h"
#import "settingsViewController.h"
#import "helpViewController.h"
#import "creditsViewController.h"
#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>
#import "BulkyServices.h"

@interface Gob1MenuViewController : UIViewController <BulkyServicesDelegate>
{
	//VIEWCONTROLLERS
	helpViewController*     _helpVC;
	loadViewController*     _loadVC;
	creditsViewController*  _creditsVC;	
	settingsViewController* _settingsVC;	
	
	//OUTLETS
	IBOutlet UIImageView* logoV;
	IBOutlet UIImageView* ppal3;
	IBOutlet UIImageView* ppal1;
	
	IBOutlet UIButton* _moreGames;
	
	//SOUND
	AVAudioPlayer* menuSFXPlayer;
	
	//ANIMATION
	bool bAnimationOn;
	
	//BULKYCHANNEL
	BulkyServicesView* bulkyView;
	UIInterfaceOrientation _orient;
}
@property(nonatomic, retain) IBOutlet helpViewController * _helpVC;
@property(nonatomic, retain) IBOutlet loadViewController * _loadVC;
@property(nonatomic, retain) IBOutlet creditsViewController * _creditsVC;
@property(nonatomic, retain) IBOutlet settingsViewController * _settingsVC;

//ANIMATIONS
- (void) plan1FinishedLeft:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context; 
- (void) plan3FinishedLeft:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context;
- (void) launchAnim_Plan1;
- (void) launchAnim_Plan3;

//NOTIFICATIONS
- (void) pauseAnimNotification;
- (void) resumeAnimNotification;
- (void) stopAnimNotification;
- (void) startAnimNotification;
- (void) pauseAnim;
- (void) resumeAnim;
- (void) stopAnim;
- (void) startAnim;

//ACTIONS
- (IBAction) newGameClicked:(id)sender;
- (IBAction) loadGameClicked:(id)sender;
- (IBAction) settingsClicked:(id)sender;
- (IBAction) helpClicked:(id)sender;
- (IBAction) creditsClicked:(id)sender;
- (IBAction) moreGamesClicked:(id)sender;

//METHODS
- (void) removeMe;
- (void) showLoadMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context;
- (void) showSettingsMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context;
- (void) showHelpMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context;
- (void) showCreditsMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context;
- (void) releaseView;

//BULKYPIX
- (void)bulkychannelWillAppear; 
- (void)bulkychannelWillDisappear; 
- (BOOL)isCategoryDisabled:(NSUInteger)icategoryid;
- (BOOL)isContentHidden:(NSUInteger)iitemid;
- (BOOL)isContentDisabled:(NSUInteger)iitemid;
- (BOOL)provideContent:(NSUInteger)iitemid quantity:(NSUInteger)qty transactionid:(NSString*)tid receipt:(NSString*)receip;
- (void)bulkyshopWillAppear; 
- (void)bulkyshopWillDisappear; 

@end
