//
//  menuigViewController.mm
//  scummvm
//
//  Created by DotEmu on 19/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
#include <semaphore.h>
#import <engines/igob/gob.h>
#import "switchViewController.h"
#import "iPhoneViewController.h"
#import "menuigViewController.h"
#import "Gob1MenuViewController.h"
#import "iphone_common.h"

//////////////////
//---GAME PARAMS
//LVL (GENERAL)
extern int idLvLCourant;
//LVL (SIMULATION)
extern bool bSimulation;
extern bool bLvLLoaded;
extern int idLvLToLoad;
extern int etat;
//GAME (GENERAL)
extern bool bTutoOn;
extern bool bMenuIngame;
extern bool bFromMenuIngame;
extern bool bMenuGob1;
extern bool bGameOverOn;
extern bool bSleepMode;
extern bool bMouseModeOn;
extern UIButton* externMenuButton;
extern UIButton* externHintButton;
//SOUND
extern AVAudioPlayer* audioPlayer;
extern bool bSoundMusicActive;
extern int idSoundSFX;
//DEFINES
extern iPhoneViewController* g_iVC;
extern switchViewController* g_switchVC;
extern menuigViewController* g_menuigVC;
extern Gob1MenuViewController* g_gob1MenuVC;
extern bool bSem;
extern sem_t* sem;
//---END
////////////////

extern NSThread* myThread;

@implementation menuigViewController
@synthesize _settingsVC;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"menuigViewController viewDidLoad");
    [super viewDidLoad];
	
	bStartAgain = false;
	
	_resume.exclusiveTouch = YES;
	
	if( bGameOverOn )
		_resume.hidden = YES;	
	else
		_resume.hidden = NO;	
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-25.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	if( bTutoOn )
	{
		_sAgain.enabled = NO;
		_load.enabled = NO;
	}
	else
	{
		_sAgain.enabled = YES;
		_load.enabled = YES;
	}

}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void)didReceiveMemoryWarning 
{
	//NSLog(@"menuigViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"menuigViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc
{
	//NSLog(@"menuigViewController dealloc");	
    [super dealloc];
}

-(void) resume
{
	//NSLog(@"menuigViewController resume");	
	[self.view removeFromSuperview];
	bMenuIngame = false;
	
	if( bMouseModeOn && !bStartAgain )
		[[NSNotificationCenter defaultCenter] postNotificationName:@"cursorModeNotif" object:nil];
	
	bStartAgain = false;
	
	externMenuButton.enabled = YES;
	externHintButton.enabled = YES;	
}

-(IBAction) resumeClicked:(id)sender
{
	//NSLog(@"menuigViewController resumeClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( bMenuIngame )
	{
		bMenuIngame = false;
		bSleepMode = false;
		if( bSem && !bTutoOn )
		{
			sem_post( sem );		
			bSem = false;
		}
		
		[NSTimer scheduledTimerWithTimeInterval:0 target:self selector:@selector(resume) userInfo:nil repeats:NO];
	}
}

-(void) againIngame
{
	etat = 2;
	[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];	
	
	if( !bGameOverOn )
		[NSTimer scheduledTimerWithTimeInterval:0.0 target:self selector:@selector(resume) userInfo:nil repeats:NO];
	else
		[NSTimer scheduledTimerWithTimeInterval:0.35 target:self selector:@selector(resume) userInfo:nil repeats:NO];
}

-(IBAction) startAgainClicked:(id)sender
{
	//NSLog(@"menuigViewController startAgainClicked");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( bMenuIngame )
	{	
		bStartAgain = true;		
		
		//start again, si diff de 1, alors simulation de base etat = 2
		if( idLvLCourant != 1 )
		{
			idLvLToLoad = idLvLCourant;
			
			[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeDown], @"type",
											   [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];
			
			[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeUp], @"type",
											   [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];
			
			[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(againIngame) userInfo:nil repeats:NO];
		}
		else //sinon, kill VM, reload VM
		{
			bSimulation = false;
			Gob::GobEngine *gg = (Gob::GobEngine*)[g_iVC getGobEngine]; 
			gg->quitGame();
			
			[[NSNotificationCenter defaultCenter] postNotificationName:@"hideButtonsNotif" object:nil];
			[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];	
			[NSTimer scheduledTimerWithTimeInterval:0.315 target:self selector:@selector(resume) userInfo:nil repeats:NO];
		}
		bLvLLoaded = false;
		bSleepMode = false;
		if( bSem )
		{
			sem_post( sem );		
			bSem = false;
		}
	}
}

-(IBAction) loadClicked:(id)sender
{
	//NSLog(@"menuigViewController settingsIGClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( !bFromMenuIngame && bMenuIngame )
	{
		bMenuIngame = false;
		bFromMenuIngame = true;
		g_menuigVC = self;
		[self.view removeFromSuperview];
		[g_switchVC switchLoad];
	}
}

-(IBAction) settingsIGClicked:(id)sender
{
	//NSLog(@"menuigViewController settingsIGClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( !bFromMenuIngame && bMenuIngame )
	{
		bMenuIngame = false;
		bFromMenuIngame = true;
		g_menuigVC = self;
		[self.view removeFromSuperview];
		[g_switchVC switchSettingsInGame];
	}
}

-(IBAction) quitClicked:(id)sender
{
	//NSLog(@"menuigViewController quitClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( bMenuIngame )
	{
		bMenuIngame = false;
		bFromMenuIngame = true;
		bMenuGob1 = true;
		[[NSNotificationCenter defaultCenter] postNotificationName:@"endTutoAgainNotif" object:nil];		
		[[NSNotificationCenter defaultCenter] postNotificationName:@"hideButtonsNotif" object:nil];
		
		if( bSoundMusicActive )
			[audioPlayer stop];		
		
		externMenuButton.enabled = YES;
		externHintButton.enabled = YES;	
		
		[self.view removeFromSuperview];
		g_gob1MenuVC.view.hidden = NO;
		[g_switchVC switchViews];
	}
}

@end
